43 Commits

Author SHA1 Message Date
Ivan Malopinsky c6fcd81155 Merge pull request #84 from koppor/patch-1
Add installation hints for Windows
2017-12-08 09:07:07 -05:00
Oliver Kopp 5b99160266 Add installation hints for Windows 2017-12-08 09:11:52 +01:00
Ivan Malopinsky 38e71f6f9d update git-fresh docs 2017-11-14 23:06:46 -05:00
Ivan Malopinsky fa9b2a38b1 1.11.0 2017-11-14 23:04:37 -05:00
Ivan Malopinsky d3f7a39b96 do not rebase local current branch against remote branch. ff-merge instead of rebasing local root 2017-11-14 23:03:43 -05:00
Ivan Malopinsky bc874fa5bd run git prune if git gc fails
resolve #83
2017-11-14 22:51:48 -05:00
Ivan Malopinsky f0c9f902a4 1.10.1 2017-07-19 20:07:55 -04:00
Ivan Malopinsky b9e145abdf Create LICENSE 2017-07-18 21:12:02 -04:00
Ivan Malopinsky a129ad766a git remote prune before remote update, resolve #79 #80 2017-07-18 21:09:27 -04:00
Ivan Malopinsky 8f4a8a326e support a global .freshignore, fix #76 2017-07-18 20:50:55 -04:00
Ivan Malopinsky 8974b650ac recover HEAD ref, fix #77 2017-04-25 22:49:30 -04:00
Ivan Malopinsky e5ac597258 .freshignore support for local and remote branch cleanup 2016-09-30 22:13:52 -04:00
Ivan Malopinsky 9999e54375 start on branch ignore support 2016-09-25 22:55:09 -04:00
Ivan Malopinsky 30657dcd75 clean tracking information for missing upstreams
fix #63
2016-09-24 22:55:09 -04:00
Ivan Malopinsky 0b191ec2f9 1.8.0 2016-08-25 20:29:41 -04:00
Ivan Malopinsky 562a4b94ca do not change branch if already on root, add tests 2016-08-25 20:29:19 -04:00
Ivan Malopinsky 799199dcc2 add version command 2016-07-04 00:00:00 -04:00
Ivan Malopinsky 33df53a989 bump version to 1.7.0 2016-05-14 00:00:00 -04:00
Ivan Malopinsky ad4a370334 update docs with -R and -W 2016-05-13 00:00:00 -04:00
Ivan Malopinsky 58851c4c15 add -W and -R to split -F 2016-05-12 00:00:00 -04:00
Ivan Malopinsky d33bde493a bump to 1.6.2 2016-03-30 12:23:19 -04:00
Ivan Malopinsky 9a061ce30b reset/rebase against remote branches 2016-03-29 11:05:34 -04:00
Ivan Malopinsky 236f95ea18 merge/rebase against local root
fix #68
2016-03-28 17:34:47 -04:00
Ivan Malopinsky 2da11516b4 1.6.1 2016-03-22 22:20:19 -04:00
Ivan Malopinsky e735f44727 integrated testing mode 2016-03-22 22:20:14 -04:00
Ivan Malopinsky 8f40e82492 1.6.0 2016-03-22 22:02:03 -04:00
Ivan Malopinsky da4e21fe5c add remote testing 2016-03-22 22:01:24 -04:00
Ivan Malopinsky 01a44ddc7c replace spaces with NULs for xargs -0 2016-03-09 22:45:08 -05:00
Ivan Malopinsky 0702c3a67b only run remote commands if remote is present, rework rebase/reset 2016-03-09 22:38:49 -05:00
Ivan Malopinsky bcde137050 bump to 1.5.0 2016-03-09 19:43:58 -05:00
Ivan Malopinsky da31f19926 Merge pull request #66 from imsky/quotes-xargs
fix xargs failure for branches with quotes in names
2016-03-08 23:40:56 -05:00
Ivan Malopinsky 2b1fb56c4a fix xargs failure for branches with quotes in names
fix #65
2016-03-08 23:40:44 -05:00
Ivan Malopinsky 4f142bf0dd update readme to include tag option 2016-02-28 00:06:48 -05:00
Ivan Malopinsky 5c76da3ebd Merge pull request #64 from imsky/stale-tags
remove local tags that do not exist on remote, fix #62
2016-02-27 18:35:53 -05:00
Ivan Malopinsky 0d632b15e1 remove local tags that do not exist on remote, fix #62 2016-02-27 18:35:29 -05:00
Ivan Malopinsky f6898b7056 1.4.0 2016-01-21 23:16:00 -05:00
Ivan Malopinsky ae2fa19df6 add [git-fresh] to logs 2016-01-20 00:00:00 -05:00
Ivan Malopinsky 2798299f11 add comments 2016-01-19 00:00:00 -05:00
Ivan Malopinsky f3fb0fc3f9 check that remote branch exists before rebasing against it 2016-01-17 00:00:00 -05:00
Ivan Malopinsky c7d9abc59e fix HEAD ref check 2016-01-16 00:00:00 -05:00
Ivan Malopinsky 80593359ca fix git directory check 2016-01-15 00:00:00 -05:00
Ivan Malopinsky 337c9679bc homebrew now supported 2015-12-08 20:13:26 -05:00
Ivan Malopinsky f18a2dc6ba add safety checks before running git-fresh 2015-12-03 20:28:04 -05:00
5 changed files with 248 additions and 40 deletions
+21
View File
@@ -0,0 +1,21 @@
MIT License
Copyright (c) 2017 Ivan Malopinsky
Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:
The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
+20 -5
View File
@@ -1,38 +1,53 @@
# git-fresh :lemon:
# git-fresh :lemon:
Keep your repo fresh with one command.
## Usage
```
Usage: git fresh [-fmrF] [-sl] [remote] [root]
Usage: git fresh [-fmrtRW] [-sl] [remote] [root]
By default, git-fresh will:
- rebase against remote current branch
- update local root (master) to match remote root
- stash changes
- prune remote branches
git-fresh will ignore any branches listed in a .freshignore file.
.freshignore should contain branch names you would like to ignore
on separate lines. The file can exist in the current Git repo
or in the home directory, i.e. ~/.freshignore.
-f: Delete stale local and remote branches
-m: Merge remote root into current branch
-r: Rebase current branch against remote root
-F: Reset local root to remote root, wipe workspace
-t: Remove local tags that do not exist on remote
-R: Reset local root to remote root
-W: Wipe workspace clean
-s: Apply stashed changes after run
-l: Only delete local stale branches
-v: Print git-fresh version and exit
remote: remote name, origin by default
root: root branch, master by default
```
## Installation
### Manual
### Manual on Linux or MacOSX
1. Clone or download
2. `cd git-fresh`
3. `sudo ./install`
### Manual on Windows
Copy the file [git-fresh](https://raw.githubusercontent.com/imsky/git-fresh/master/git-fresh) to `usr\bin` in your git installation directory.
This usually is `C:\Program Files\Git\usr\bin`.
### Package
* [Homebrew](http://brew.sh/): `brew install git-fresh`
* [bpkg](http://www.bpkg.io/): `bpkg install imsky/git-fresh`
## License
+205 -33
View File
@@ -1,35 +1,58 @@
#!/usr/bin/env bash
# git-fresh
# https://github.com/imsky/git-fresh
# By Ivan Malopinsky - http://imsky.co
# MIT License
usage () {
cat << EOD
Usage: git fresh [-fmrF] [-sl] [remote] [root]
Usage: git fresh [-fmrtRW] [-sl] [remote] [root]
By default, git-fresh will:
- rebase against remote current branch
- update local root (master) to match remote root
- stash changes
- prune remote branches
git-fresh will ignore any branches listed in a .freshignore file.
.freshignore should contain branch names you would like to ignore
on separate lines. The file can exist in the current Git repo
or in the home directory, i.e. ~/.freshignore.
-f: Delete stale local and remote branches
-m: Merge remote root into current branch
-r: Rebase current branch against remote root
-F: Reset local root to remote root, wipe workspace
-t: Remove local tags that do not exist on remote
-R: Reset local root to remote root
-W: Wipe workspace clean
-s: Apply stashed changes after run
-l: Only delete local stale branches
-v: Print git-fresh version and exit
remote: remote name, origin by default
root: root branch, master by default
EOD
exit 0;
exit 0
}
say () {
echo "[git-fresh] $@" 1>&2
}
die () {
say $@
exit 1
}
error () {
echo -n "[git-fresh] error on line $1"
die "Error on line $1: $(head -n $1 $0 | tail -1)"
}
trap 'error $LINENO' ERR
while getopts ":fmrslF" opt; do
while getopts ":fmrtslRWTv" opt; do
case $opt in
f)
FORCE_DELETE_STALE=true
@@ -40,14 +63,26 @@ while getopts ":fmrslF" opt; do
r)
REBASE=true
;;
t)
TAGS=true
;;
s)
APPLY_STASH=true
;;
l)
DELETE_ONLY_LOCAL=true
;;
F)
FORCE_LOCAL_RESET=true
R)
RESET_ROOT=true
;;
W)
WIPE_WORKSPACE=true
;;
T)
TEST=true
;;
v)
VERSION=1.11.0
;;
*)
usage
@@ -58,30 +93,120 @@ done
shift $((OPTIND-1))
CURRENT=$(git rev-parse --abbrev-ref HEAD)
# Are we in version mode?
if [[ ! -z $VERSION ]]; then
echo git-fresh $VERSION
exit 0
fi
# Are we in testing mode?
if [[ $TEST = true ]]; then
PATH=$(pwd):$PATH
TEST_DIR=/tmp/git-fresh-test
fail_test () {
echo 'Tests failed!'
rm -rf $TEST_DIR
exit 1
}
rm -rf $TEST_DIR; mkdir -p $TEST_DIR; cd $TEST_DIR
git init; touch test; git add test; git commit -am 'test'
git checkout -b test; rm test; git commit -am 'delete test'
git checkout master; git merge test; git checkout test
git-fresh -fr; git rev-parse --verify test && fail_test || true
git checkout -b test; git checkout master; git-fresh; git checkout -
git rev-parse --abbrev-ref HEAD | grep -q test || fail_test
rm -rf $TEST_DIR
echo 'Tests passed!'
exit 0
fi
# Are we inside a git repository?
INSIDE_GIT_REPO=$(git rev-parse --is-inside-work-tree 2> /dev/null)
if [[ -z "$INSIDE_GIT_REPO" ]]; then
die "Not a git repository"
fi
# Are we in a non-empty git repository?
TOP_LEVEL_DIRECTORY=$(git rev-parse --show-toplevel)
REMOTE=${1:-origin}
ROOT=${2:-master}
git remote update
git remote prune $REMOTE
if [[ $(ls -1 "$TOP_LEVEL_DIRECTORY/.git/refs/heads" | wc -l | xargs) -eq "0" ]]; then
if git rev-parse --verify "$ROOT"; then
git rev-parse "$ROOT" > "$TOP_LEVEL_DIRECTORY/.git/refs/heads/$ROOT"
else
(git fsck --lost-found &> /dev/null; git checkout "$ROOT") || die "No HEAD ref available"
fi
fi
CURRENT=$(git rev-parse --abbrev-ref HEAD)
if [[ $(git remote -v | wc -l) -gt "0" ]]; then
REMOTES=true
fi
# Is this branch in .freshignore?
FRESH_IGNORE="$TOP_LEVEL_DIRECTORY/.freshignore"
if [[ ! -f $FRESH_IGNORE ]]; then
FRESH_IGNORE="~/.freshignore"
fi
if [[ -f $FRESH_IGNORE ]]; then
if [[ ! -z $(grep -Fx "$CURRENT" "$FRESH_IGNORE") ]]; then
die "Branch $CURRENT is ignored"
fi
fi
STASH_STAMP=git-fresh-$(date +%s)
# Stash changed files
if ! git diff-files --quiet; then
git stash save $STASH_STAMP
fi
git rebase $REMOTE $CURRENT
if [[ $REMOTES = true ]]; then
# Update remotes and prune stale remotes
git checkout $ROOT > /dev/null 2>&1
if [[ "$FORCE_LOCAL_RESET" = true ]]; then
git clean -dfx
git reset --hard $REMOTE/$ROOT
else
git rebase -q $REMOTE/$ROOT
git remote prune $REMOTE
git remote update $REMOTE
git remote prune $REMOTE
fi
# If we are not already on root branch, switch to root branch (master)
if [[ "$ROOT" != "$CURRENT" ]]; then
git checkout $ROOT > /dev/null 2>&1
fi
# Wipe workspace?
if [[ $WIPE_WORKSPACE = true ]]; then
git clean -dfx
fi
if [[ $REMOTES = true ]]; then
# Reset root?
if [[ $RESET_ROOT = true ]]; then
git reset --hard $REMOTE/$ROOT
fi
git pull --quiet --ff-only $REMOTE $ROOT || say "Fast forward merge failed on $ROOT. You can reset local $ROOT by running git fresh -R."
fi
# Compute stale branches
SMART_STALE=$(git branch -a --merged | tr -d "\* " | grep -Ev ">|$ROOT" | cat)
LOCAL_STALE=$(grep -Ev "^remotes/" <<< "$SMART_STALE" | cat)
@@ -93,53 +218,100 @@ REMOTE_STALE=${REMOTE_STALE//remotes\/$REMOTE\/}
if [[ ! -z "${SMART_STALE// }" ]]; then
if [[ ! -z "${LOCAL_STALE// }" ]]; then
STALE_BRANCHES=true
if [[ -f "$FRESH_IGNORE" ]]; then
LOCAL_STALE=$(echo -n $LOCAL_STALE | tr " " "\n" | grep -Fxvf "$FRESH_IGNORE" | tr "\n" " ")
if [[ -z $LOCAL_STALE ]]; then
STALE_BRANCHES=false
fi
fi
if [[ "$FORCE_DELETE_STALE" = true ]]; then
echo -n $LOCAL_STALE | xargs git branch -d 2> /dev/null
echo -n $LOCAL_STALE | tr " " "\0" | xargs -0 git branch -d 2> /dev/null
else
echo "Local stale branches found:" $(echo -n $LOCAL_STALE | tr "\n" " ")
if [[ $STALE_BRANCHES = true ]]; then
say "Local stale branches found:" $(echo -n $LOCAL_STALE | tr "\n" " ")
fi
fi
fi
if [[ ! -z "${REMOTE_STALE// }" ]]; then
STALE_BRANCHES=true
if [[ -f "$FRESH_IGNORE" ]]; then
REMOTE_STALE=$(echo -n $REMOTE_STALE | tr " " "\n" | grep -Fxvf "$FRESH_IGNORE" | tr "\n" " ")
if [[ -z $REMOTE_STALE ]]; then
STALE_BRANCHES=false
fi
fi
if [[ "$FORCE_DELETE_STALE" = true ]]; then
if [[ "$DELETE_ONLY_LOCAL" != true ]]; then
echo -n $REMOTE_STALE | xargs git push $REMOTE --delete
echo -n $REMOTE_STALE | tr " " "\0" | xargs -0 git push $REMOTE --delete
fi
else
echo "Remote stale branches found:" $(echo -n $REMOTE_STALE | tr "\n" " ")
if [[ $STALE_BRANCHES = true ]]; then
say "Remote stale branches found:" $(echo -n $REMOTE_STALE | tr "\n" " ")
fi
fi
fi
if [[ "$FORCE_DELETE_STALE" != true && "$STALE_BRANCHES" = true ]]; then
echo "Delete stale branches with: git fresh -f"
say "Delete stale branches with: git fresh -f"
fi
fi
# Remove tracking information for missing upstreams
if [[ ! -z $(git branch -vv | grep -F "[$REMOTE/$CURRENT: gone]") ]]; then
git branch --unset-upstream $CURRENT
fi
# Rebase or merge remote root against local branch
if [[ ! -z $(git rev-parse --verify --quiet "$CURRENT") ]]; then
git checkout $CURRENT 2> /dev/null
if [[ "$ROOT" != "$CURRENT" ]]; then
git checkout $CURRENT
fi
if [ "$REBASE" = true ] && [ "$MERGE" = true ]; then
echo "Rebase and merge enabled, skipping both"
say "Rebase and merge enabled, skipping both"
else
if [[ "$REBASE" = true ]]; then
git rebase $REMOTE/$ROOT
fi
if [[ "$REMOTES" = true ]]; then
if [[ "$REBASE" = true ]]; then
git rebase $ROOT
fi
if [[ "$MERGE" = true ]]; then
git merge --no-edit $REMOTE/$ROOT
if [[ "$MERGE" = true ]]; then
git merge --no-edit $ROOT
fi
fi
fi
else
echo "$CURRENT branch was stale, staying on $ROOT"
fi
# Remove local tags that are missing on the remote
if [[ "$TAGS" = true ]]; then
REMOTE_TAGS=$(git ls-remote --tags $REMOTE | cut -f 2)
LOCAL_TAGS=$(git show-ref --tags | cut -d' ' -f 2)
for tag in $LOCAL_TAGS; do
if [[ -z $(grep $tag <<< "$REMOTE_TAGS" | cat) ]]; then
MISSING_TAG="${tag//refs\/tags\/}"
git tag -d $MISSING_TAG
fi
done
fi
# Restore stashed changes
if [[ ! -z $(git stash list | grep $STASH_STAMP | cat) ]]; then
if [[ "$APPLY_STASH" = true ]]; then
git stash pop
else
echo "Stashed changes present, apply with: git stash pop"
say "Stashed changes present, apply with: git stash pop"
fi
fi
git gc --auto --prune=now
if ! git gc --auto --force; then
git prune
rm -rf "$TOP_LEVEL_DIRECTORY/.git/gc.log"
fi
View File
+2 -2
View File
@@ -1,8 +1,8 @@
{
"name": "git-fresh",
"version": "1.2.3",
"version": "1.11.0",
"description": "Utility to keep Git repositories fresh",
"global": true,
"repo": "imsky/git-fresh",
"install": "sudo ./install"
"install": "sudo ./install.sh"
}